searchNodes=[{"ref":"Hub.html","title":"Hub","module":"Hub","type":"module","doc":"Pub-sub hub Subscription is done with a pattern. Example: Hub.subscribe(&quot;global&quot;, %{count: count} when count &gt; 42) Hub.publish(&quot;global&quot;, %{count: 45, message: &quot;You rock!&quot;})"},{"ref":"Hub.html#publish/2","title":"Hub.publish/2","module":"Hub","type":"function","doc":"Publishes the term to all subscribers that matches it Returns the number of subscribers that got the message"},{"ref":"Hub.html#subscribe/3","title":"Hub.subscribe/3","module":"Hub","type":"macro","doc":"Convenience macro for subscribing without the need to unquote the pattern. example: Hub.subscribe(&quot;global&quot;, %{count: count} when count &gt; 42)"},{"ref":"Hub.html#subscribe_quoted/3","title":"Hub.subscribe_quoted/3","module":"Hub","type":"function","doc":"Subscribes to the quoted pattern in the given channel_name example: Hub.subscribe(&quot;global&quot;, quote do: %{count: count} when count &gt; 42)"},{"ref":"Hub.html#subscribers/1","title":"Hub.subscribers/1","module":"Hub","type":"function","doc":"Get all subscribers from channel"},{"ref":"Hub.html#traverse_pin/2","title":"Hub.traverse_pin/2","module":"Hub","type":"function","doc":""},{"ref":"Hub.html#unsubscribe/1","title":"Hub.unsubscribe/1","module":"Hub","type":"function","doc":"Unsubscribes using the reference returned on subscribe"},{"ref":"Hub.Application.html","title":"Hub.Application","module":"Hub.Application","type":"module","doc":"OTP application for Hub"},{"ref":"Hub.Application.html#start/2","title":"Hub.Application.start/2","module":"Hub.Application","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Hub.Channel.html","title":"Hub.Channel","module":"Hub.Channel","type":"module","doc":"GenServer that handles a single channel. This serializes publishes, subscribes and unsubscribes on that channel, and makes sure no race condition can occur."},{"ref":"Hub.Channel.html#child_spec/1","title":"Hub.Channel.child_spec/1","module":"Hub.Channel","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Hub.Channel.html#init/1","title":"Hub.Channel.init/1","module":"Hub.Channel","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Hub.Channel.html#publish/2","title":"Hub.Channel.publish/2","module":"Hub.Channel","type":"function","doc":"Publishes the message to all matching subscribers of this channel. Returns number of subscribers that the message was sent to."},{"ref":"Hub.Channel.html#start_link/1","title":"Hub.Channel.start_link/1","module":"Hub.Channel","type":"function","doc":"Starts the Channel"},{"ref":"Hub.Channel.html#subscribe_quoted/3","title":"Hub.Channel.subscribe_quoted/3","module":"Hub.Channel","type":"function","doc":"Subscribes with the quoted pattern"},{"ref":"Hub.Channel.html#subscribers/1","title":"Hub.Channel.subscribers/1","module":"Hub.Channel","type":"function","doc":"Get all subscribers from channel"},{"ref":"Hub.Channel.html#unsubscribe/1","title":"Hub.Channel.unsubscribe/1","module":"Hub.Channel","type":"function","doc":"Unsubscribes using the reference returned on subscribe"},{"ref":"Hub.Channel.html#t:count/0","title":"Hub.Channel.count/0","module":"Hub.Channel","type":"type","doc":""},{"ref":"Hub.Channel.html#t:pattern/0","title":"Hub.Channel.pattern/0","module":"Hub.Channel","type":"type","doc":""},{"ref":"Hub.Channel.html#t:subscribe_option/0","title":"Hub.Channel.subscribe_option/0","module":"Hub.Channel","type":"type","doc":""},{"ref":"Hub.Channel.html#t:subscribe_options/0","title":"Hub.Channel.subscribe_options/0","module":"Hub.Channel","type":"type","doc":""},{"ref":"Hub.Channel.html#t:subscription_ref/0","title":"Hub.Channel.subscription_ref/0","module":"Hub.Channel","type":"type","doc":""},{"ref":"Hub.ChannelRegistry.html","title":"Hub.ChannelRegistry","module":"Hub.ChannelRegistry","type":"module","doc":"Keeps track of channel processes with channel names as keys."},{"ref":"Hub.ChannelRegistry.html#child_spec/1","title":"Hub.ChannelRegistry.child_spec/1","module":"Hub.ChannelRegistry","type":"function","doc":""},{"ref":"Hub.ChannelRegistry.html#lookup/1","title":"Hub.ChannelRegistry.lookup/1","module":"Hub.ChannelRegistry","type":"function","doc":"Looks up the given channel name"},{"ref":"Hub.ChannelRegistry.html#register/1","title":"Hub.ChannelRegistry.register/1","module":"Hub.ChannelRegistry","type":"function","doc":"Registers the channel with the channel_name"},{"ref":"Hub.ChannelRegistry.html#start_link/0","title":"Hub.ChannelRegistry.start_link/0","module":"Hub.ChannelRegistry","type":"function","doc":"Starts the registry"},{"ref":"Hub.ChannelSupervisor.html","title":"Hub.ChannelSupervisor","module":"Hub.ChannelSupervisor","type":"module","doc":"Dynamic supervisor for Channel processes"},{"ref":"Hub.ChannelSupervisor.html#child_spec/1","title":"Hub.ChannelSupervisor.child_spec/1","module":"Hub.ChannelSupervisor","type":"function","doc":""},{"ref":"Hub.ChannelSupervisor.html#start_child/1","title":"Hub.ChannelSupervisor.start_child/1","module":"Hub.ChannelSupervisor","type":"function","doc":"Starts a Channel worker with the given channel name"},{"ref":"Hub.ChannelSupervisor.html#start_link/0","title":"Hub.ChannelSupervisor.start_link/0","module":"Hub.ChannelSupervisor","type":"function","doc":"Starts the supervisor"},{"ref":"Hub.Subscriber.html","title":"Hub.Subscriber","module":"Hub.Subscriber","type":"module","doc":"State for a single subscriber"},{"ref":"Hub.Subscriber.html#new/4","title":"Hub.Subscriber.new/4","module":"Hub.Subscriber","type":"function","doc":""},{"ref":"Hub.Subscriber.html#t:t/0","title":"Hub.Subscriber.t/0","module":"Hub.Subscriber","type":"type","doc":""}]